using System;
using System.Web;
using System.Web.UI;

namespace AjaxTest
{
	public class CustomControl : Control
	{
		protected override void OnInit(EventArgs e)
		{
			base.OnInit(e);
			Ajax.Manager.Register(this);
		}

		protected override void Render(HtmlTextWriter writer)
		{
			writer.Write("<span onclick=\"this.firstChild.data = AjaxTest.CustomControl.ToUpper(this.firstChild.data).value;\">" + Text + "</span>");
		}

		public string Text
		{
			get { return ViewState["Text"].ToString(); }
			set { ViewState["Text"] = value; }
		}

		[Ajax.Method]
		public string ToUpper(string s)
		{
			return s.ToUpper();
		}
	}
}
