using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace AjaxTest
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox _a;
		protected System.Web.UI.WebControls.TextBox _b;
		protected System.Web.UI.WebControls.DropDownList _tableList;
		protected System.Web.UI.WebControls.DropDownList _setList;
		protected AjaxTest.CustomControl _cc;
		protected System.Web.UI.WebControls.TextBox TextBox2;

		private void Page_Load(object sender, System.EventArgs e)
		{
			Ajax.Manager.Register(this, "My.Page", Ajax.Debug.None);
		}

		[Ajax.Method]
		public string SayHello()
		{
			return "Hello, AJAX!";
		}

		[Ajax.Method]
		public string ToUpper(string s)
		{
			return s.ToUpper();
		}

		[Ajax.Method]
		public int Add(int a, int b)
		{
			return a + b;
		}

		[Ajax.Method]
		public DataTable GetDataTable()
		{
			DataTable table = new DataTable();
			table.TableName = "Items";
			table.Columns.Add("text");
			table.Columns.Add("value");
			table.Rows.Add(new object[] { "foo", "1" });
			table.Rows.Add(new object[] { "bar", "2" });
			table.Rows.Add(new object[] { "baz", "3" });
			table.Rows.Add(new object[] { "quux", "4" });
			System.Threading.Thread.Sleep(1000);
			return table;
		}

		[Ajax.Method]
		public DataSet GetDataSet()
		{
			DataSet ds = new DataSet();
			ds.Tables.Add(GetDataTable());
			return ds;
		}

		[Ajax.Method]
		public Foo GetFoo()
		{
			Foo foo = new Foo();
			return foo;
		}

		[Ajax.Method]
		public DateTime GetNow()
		{
			return DateTime.Now;
		}

		[Ajax.Method]
		public string GetString()
		{
			return "foo\nbar\u0001baz\u00A0quux";
		}

		[Ajax.Method]
		public string ThrowException()
		{
			object o = null;
			return o.ToString();
		}

		#region Web Form Designer generated code
			override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}

public class Foo
{
	public string Bar
	{
		get { return "baz"; }
	}
}
